--[[
@title Remote gluonpilot trigger
@param t Use tagging
@default t 0
@param u Use separate log
@default u 1
--]]


require "EXIFModule"


function GetImgDir(FileName)

    -- For a given image file name this function searches for the folder
    -- where the image is stored.

    local F
    local ImgDir = nil
    local Path = "A/DCIM"
    -- get all directory names under A/DCIM
    local Dir = os.listdir(Path, false)
    local Count = #Dir
    local I = 1

    -- remove any directory name that is not "nnnCANON"
    --repeat
    --    local S, E = string.find(Dir[I], "%d%d%dCANON")
    --    if S == nil and E == nil then table.remove(Dir, I) end
    --    I = I + 1
    --until Dir[I] == nil

    -- sort the table so that the highest folder number is at the end of the table
    table.sort(Dir)

    -- Search for the image, start with the folder with the highest number because
    -- probability to find the image in newer folders is higher.
    I = #Dir
    repeat
        -- test whether file exists
        F = os.stat(Path.."/"..Dir[I].."/"..FileName)
        if not(F == nil) then
            ImgDir = Path.."/"..Dir[I].."/"
        end
        I = I - 1
    until I == 0 or ImgDir ~= nil

    return ImgDir

end

CurrDir = "A/DCIM/"

function FindCurrDir(ImgName)
        F = os.stat(CurrDir..ImgName)
        if F == nil then
            if (CurrDir == "A/DCIM/") then
               -- if file not found search all directories for the image
               ImgDir = GetImgDir(ImgName)
               if ImgDir == nil then
                   -- image file not found in any directory
                   print(ImgName, " not found!")
                   return false
               else
                   CurrDir = ImgDir
                   return true
               end
	    else
	       print(ImgName, " not found!")
            end
        else
            return true
        end
end

function TagImage(ImgName, TagText)
    local P = JPEGImage -- JPEGImage definition in modul EXIFModul.lua
    local F, ImgDir, ImgFound

    ImgFound = false
    --CurrDir = "A/DCIM/"
        -- test whether image file exists in current image directory
        ImgFound = FindCurrDir(ImgName)

        -- mark image
        if ImgFound then
            P:new(CurrDir..ImgName)
            P:SetUserComment(TagText)
        end

end




--btn = "left"
btn = "remote"

trigger = 0	
print_screen(true)

logfile = nil
logfilename = nil

if (get_drive_mode() == 0) then
	print ("single shot mode")
else
	print ("continuous shooting mode")
end


while true do
        trigger_map = {}
        first_number = -1

	repeat 
	    --print ("waiting 4 trigger")
	    sleep(100)
	until is_pressed(btn)

	start_time=get_tick_count()
	trigger = trigger + 1
	print("Trigger", trigger)

	shot_count = get_exp_count()

	if get_drive_mode() ~= 0 then  -- continuous shooting: determine focus and light per trigger
		press("shoot_half")
		repeat sleep(100) until get_shooting() == true	
		release("shoot_half")
		repeat sleep(100) until get_shooting() == false	
		set_aflock(1)
		press("shoot_full")
	end

	while is_pressed(btn) do
		
            if get_drive_mode() == 0 then
		    press("shoot_full")
	    end 

	    repeat 
	        sleep(50) 
	        new_count = get_exp_count() 
		--print ("waiting 4 count")
	    until new_count > shot_count

            if get_drive_mode() == 0 then
		    release("shoot_full")
	    end 

	    tick_since_trigger = get_tick_count()-start_time
	    ImgName = "IMG_"..string.rep("0", 4-string.len(new_count))..new_count..".JPG"
	    print(ImgName..";", tick_since_trigger)

	    if first_number == -1 then
		    first_number = new_count
	    end

	    if u == 1 then
	        --logfile=io.open("A/CHDK/LOGS/log"..first_number..".txt","ab")
	        if logfile == nil then
		    if logfilename == nil then
		       -- first call, image might not be available
		       sleep(1100)
		       --if FindCurrDir(ImgName) == true then
			--  logfilename = CurrDir.."log"..string.rep("0", 4-string.len(first_number))..first_number..".txt"
		       --else
		          logfilename = "A/CHDK/LOGS/log"..string.rep("0", 4-string.len(first_number))..first_number..".txt"
		       --end
		       print("logfilename "..logfilename)
                       logfile=io.open(logfilename,"wb")
		    else
                       logfile=io.open(logfilename,"ab")
		    end
		end
		if (logfile ~= nil) then
                   logfile:write(trigger..";"..ImgName..";"..tick_since_trigger.."\n")
	        else 
		   print("no log file")
	        end
	    end

	    if (t ==  1) then
	    	trigger_map[new_count] = tick_since_trigger
            end
	    shot_count = new_count
	end
	release("shoot_full")

	if u == 1 then
	    if logfile ~= nil then
	    	logfile:close()
	    	logfile = nil
	    end
        end
        
	if t == 1 then
	    --  try to exif tag
	    for i=first_number,first_number+10000 do
                if trigger_map[i] ~= nil then
                      ImgName = "IMG_"..string.rep("0", 4-string.len(i))..i..".JPG"
		      TagImage(ImgName, ""..trigger..";"..trigger_map[i])
		      print("Tagging "..ImgName)
	        else
	             break
	        end
	    end
	    print("Done tagging!")
	end

end	
